(define-macro (eval-at-macro-expansion-time . code)
    (eval (cons 'begin code))
    '(begin))

(eval-at-macro-expansion-time 
    (##include "match-support.scm"))

(##include "match-support.scm")

(define-runtime-macro (match/action on-success on-fail datum . clauses)
  (let ((tmp (gensym))
	(succ (gensym))	 
	(fail (gensym))) 

    `(let ((,tmp ,datum)
	   (,succ (lambda () ,on-success)) ;; the thunk for success is lifted
	   (,fail (lambda () ,on-fail)))   ;; the thunk for failure is lifted
       
       ,(compile-pattern-match `(,succ) `(,fail) clauses tmp))))


(define-runtime-macro (match datum . clauses)
  (let ((tmp (gensym))
		(fail (gensym)))

	`(let* ((,tmp ,datum)
			(,fail (lambda () 
					 (raise 
					   (list bad-match: ,tmp)))))
	   ,(compile-pattern-match 
		  #f 
		  `(,fail)
		  clauses
		  tmp))))

(define-runtime-macro (define/match name . clauses)
    (let ((arguments-name (gensym)))
         `(define (,name . ,arguments-name)
                (match ,arguments-name ,@clauses))))

(define-runtime-macro (define/match/action name on-success on-fail . clauses)
    (let ((arguments-name (gensym)))
         `(define (name . ,arguments-name)
                (match/action 
                    ,on-success 
                    ,on-fail 
                    ,arguments-name 
                    ,@clauses))))

(define-runtime-macro (lambda/match . clauses)
    (let ((arguments-name (gensym)))
         `(lambda (#!rest ,arguments-name)
                (match ,arguments-name ,@clauses))))

(define-runtime-macro (lambda/match/action on-success on-fail . clauses)
    (let ((arguments-name (gensym)))
         `(lambda (#!rest ,arguments-name)
                (match/action 
                    ,on-success 
                    ,on-fail 
                    ,arguments-name 
                    ,@clauses))))

(define-runtime-macro (define-macro/match name . clauses)
    (let ((arguments-name (gensym)))
         `(define-macro (,name . ,arguments-name)
                (match ,arguments-name ,@clauses))))

(define-runtime-macro (define-macro/match/action name on-success on-fail . clauses)
    (let ((arguments-name (gensym)))
         `(define-macro (name . ,arguments-name)
                (match/action 
                    ,on-success 
                    ,on-fail 
                    ,arguments-name 
                    ,@clauses))))

