;; File: "termite#.scm"
;; Copyright (C) 2005-2008 Guillaume Germain

(##include "termite-macro#.scm")

;; This is the declaration file for the Termite system
(##namespace ("termite#" 
			  ;; Termite "primordials"
			  self ! ? ?? !? on make-node spawn pid?
			  spawn-link remote-spawn remote-spawn-link
			  ;; Useful
			  make-tag current-node
			  ;; Process linking for error propagation
			  inbound-link outbound-link full-link
			  ;; Wrap Gambit's I/O
			  spawn-output-port spawn-input-port
			  ;; Exceptions...
			  termite-exception? ;; actually that has to be exported for RECV ... :(
			  ;; Migration
			  migrate-task migrate/proxy 
			  ;; Useful condition reporting/logging procedures
			  warning debug info
			  ;; Node stuff
			  node-init node? node-host node-port 
			  ;; Nameserver mechanism
			  make-nameserver-node 
			  ;; OTP-style stuff (genserver)
			  make-server-plugin server:start server:start-link 
			  server:call server:cast server:stop 
			  ;; Distributed data structures
			  make-dict dict? dict->list dict-for-each dict-search 
			  dict-set! dict-ref dict-length
			  ;; Publishing and resolving names for services
			  publish-service unpublish-service resolve-service remote-service
			  ;; default init and node names for convenience
			  init node1 node2
			  *termite-nameserver-port*
			  *termite-cookie*
			  ;; Useful
			  ping shutdown! start-tcp-server
              ;; added by Vasil
                process-data-ref process-data-set! 
                terminate! suspend! resume!
                %wait-for %alive?
                process-clone! 
                process-update! 
                process-replace! 
                process-migrate! 
                process-migrate/proxy! 
            ;; from tags
        	    generate-tag-u64
            ;; from match-support
                compile-pattern-match
            ;; from data.scm
                ;;cells
                make-cell
                cell-ref
                cell-set!
                cell-empty!
                cell-empty?
                ;; dicts
                make-dict
                dict?
                dict-length
                dict-ref
                dict-set!
                dict-search
                dict-for-each
                dict->list
                ;; bags
                make-bag
                bag?
                bag-length
                bag-add!
                bag-remove!
                bag-member?
                bag-search
                bag-for-each
                bag->list
                ;;termite internals
            	handle-exception-message
			  ))

;; ----------------------------------------------------------------------------
;; Macros only!
(##include "match.scm")
(##include "recv.scm")
(##include "deftype.scm")
